var i18n = require('../../i18n')

var FormController = function() {
}

FormController.prototype.init = function(scope, form) {
  this.scope = scope

  scope.submitLabel = scope.submitLabel || i18n.t('BUTTON_CREATE')

  this._onSubmit = this.scope.onSubmit
}

FormController.prototype._clear = function() {
  this.scope.fields.map(function(field) {
    field.error = false
  })
}

FormController.prototype._getValues = function() {
  return this.scope.fields.reduce(function(acc, field) {
    acc[field.name] = field.value
    return acc
  }, {})
}

FormController.prototype.onSubmit = function(event) {
  this.fields = this.scope.fields
  this._clear()

  var requiredButEmptyFields = this.fields.filter(function(field) {
    return field.required && !field.value
  }).map(function(field) {
    field.error = { required: 'required' }
    return field
  })

  if (!requiredButEmptyFields.length) {
    return this._onSubmit(this._getValues())
  } else {
    this._render()
  }
}

FormController.prototype._render = function() {
  if (!this.scope.$$phase) {
    this.scope.$digest()
  }
}

module.exports = FormController
