var ng = require('angular-bsfy')

var template = require('./template')
var controller = require('./controller')

var GridDirective = function() {
  return {
    restrict: 'C',
    template: template,
    scope: {
      headers: '=',
      table: '=',
      query: '=?',
      onLineClick: '=?'
    },
    replace: true,
    controller: controller,
    compile: function() {
      return {
        post: function($scope, $element) {
          var ctrl = $element.controller('gridDirective')
          ctrl.init($scope)

          $scope.$on('$destroy', function() {
            ctrl.destroy($scope)
          })
        }
      }
    }
  }
}

var mod = ng.module('appGrid', [])
mod.directive('gridDirective', GridDirective)

module.exports = mod
