var Session = require('../session')
var esES = require('./es-ES')
var enGB = require('./en-GB')

var DEFAULT_LOCALE = 'es-ES'

var i18nInstance = null

var I18n = function () {
  if (i18nInstance) return i18nInstance

  this.locale = this._loadLocale() || DEFAULT_LOCALE

  i18nInstance = this
}

I18n.prototype._loadLocale = function() {
  return Session.get('language')
}

I18n.prototype.getLocal = function() {
  return this.locale
}

I18n.prototype.setLocale = function(locale) {
  if (!locale) return
  this.locale = locale
}

I18n.prototype.t = function(label) {
  if (this.locale === 'es-ES') return esES[label]
  if (this.locale === 'en-GB') return enGB[label]
}

module.exports = I18n
