var sweetAlert = require('sweetalert2')
var i18n = require('../../i18n')
var promise = require('bluebird')

var sweetAlertWrapper = {}

sweetAlertWrapper.showAlert = function(title, text, type) {
  var options = {type: type, timer: 2000, allowOutsideClick: false}
  title && (options.title = title)
  text && (options.text = text)
  return sweetAlert(options)
    .catch(function(error) {
      if (error === 'timer' || error === 'cancel')
        return Promise.resolve()
      return Promise.reject(error)
    })
}

sweetAlertWrapper.success = function(title, text) {
  return sweetAlertWrapper.showAlert(title, text, 'success')
}

sweetAlertWrapper.error = function(title, text) {
  return sweetAlertWrapper.showAlert(title, text, 'error')
}

sweetAlertWrapper.warning = function(title, text) {
  return sweetAlertWrapper.showAlert(title, text, 'warning')
}

sweetAlertWrapper.askDelete = function() {
  return sweetAlert({
    title: i18n.t('PROMPT_ASK_DELETE_TITLE'),
    type: 'question',
    showCancelButton: true,
    showConfirmButton: true,
    cancelButtonText: i18n.t('BUTTON_CANCEL'),
    cancelButtonClass: 'button-error',
    confirmButtonClass: 'button-success'
  })
}

module.exports = sweetAlertWrapper