var TextField = require('../../../directives/form/fields/text')
var i18n = require('../../../i18n')

var FormFields = function() {
  this.eanField = new TextField('ean').setRequired().setPlaceholder(i18n.t('FIELD_EAN'))
  this.nameField = new TextField('name').setRequired().setPlaceholder(i18n.t('FIELD_NAME'))
}

FormFields.prototype.getEanField = function() {
  return this.eanField
}

FormFields.prototype.getNameField = function() {
  return this.nameField
}

FormFields.prototype.loadFields = function(values) {
  var fields = [
    this.nameField,
    new TextField('price').setRequired().setPlaceholder(i18n.t('FIELD_PRICE')),
    new TextField('listPrice').setRequired().setPlaceholder(i18n.t('FIELD_LIST_PRICE')),
    this.eanField
  ]

  values = values || {}
  values.name && fields[0].setValue(values.name)
  values.price && fields[1].setValue(values.price)
  values.listPrice && fields[2].setValue(values.listPrice)
  values.ean && fields[3].setValue(values.ean)

  return fields
}

module.exports = FormFields
