var ItemTable = require('../../../tables/').item
var squel = require('squel')
var footerButtons = require('./footer-buttons')
var i18n = require('../../../i18n')

var GRID_HEADERS = {
  name: { label: 'GRID_TH_NAME' },
  price: { label: 'GRID_TH_PRICE' },
  listPrice: { label: 'GRID_TH_LIST_PRICE' }
}

var CatalogListController = function(scope, state) {
  scope.gridHeaders = GRID_HEADERS
  scope.gridTable = ItemTable
  scope.onLineClick = this.onLineClick.bind(this)
  scope.gridDataQuery = this.getDataQuery()
  scope.footerButtons = footerButtons(state)
  this.state = state
  scope.title = i18n.t('TITLE_CATALOG')
}

CatalogListController.prototype.getDataQuery = function() {
  return squel.select()
    .from(ItemTable.name)
    .fields(['id', 'name', 'price', 'listPrice'])
    .toString()
}

CatalogListController.prototype.onLineClick = function(itemId) {
  this.state.go('catalogItem', { itemId: itemId })
}

module.exports = CatalogListController
