var database = require('../../../database')
var deliveryNoteLineTable = require('../../../tables').deliveryNoteLine
var alert = require('../../../lib/alert')

var DeliveryNoteLineEditorController = function(scope, state) {
  var self = this
  this.scope = scope
  this.state = state
  scope.lineTableName = deliveryNoteLineTable.name

  this.scope.mainButtons = [{
    icon: 'ion-trash-b',
    class: 'icon-error',
    action: function() {
      self.deleteItem()
    }
  }]
}

DeliveryNoteLineEditorController.prototype.deleteItem = function() {
  var self = this
  return alert.askDelete()
  .then(function() {
    return database.delete(
      deliveryNoteLineTable,
      { id: self.scope.deliveryNoteLineId }
    )
  })
  .then(function() {
    alert.success()
    return self.state.go('deliveryNoteLine')
  })
  .catch(function(error) {
    if (error === 'cancel') return //alert cancel
    console.error(error)
    return alert.error()
  })
}

DeliveryNoteLineEditorController.prototype._render = function() {
  if (!this.scope.$$phase) {
    this.scope.$digest()
  }
}

module.exports = DeliveryNoteLineEditorController
