var deliveryNoteTable = require('../../../tables').deliveryNote
var orderTable = require('../../../tables').order
var database = require('../../../database')
var squel = require('squel')
var footerButtons = require('./footer-buttons')
var i18n = require('../../../i18n')

var GRID_HEADERS = {
  name: { label: 'GRID_TH_NAME' },
  date: { label: 'GRID_TH_DATE' },
  status: { label: 'GRID_TH_STATUS' },
  orderName: { label: 'GRID_TH_ORDER' }
}

var DeliveryNoteListController = function(scope, state) {
  this.state = state
  scope.gridHeaders = GRID_HEADERS
  scope.gridTable = deliveryNoteTable
  scope.onLineClick = this.onLineClick.bind(this)
  scope.gridDataQuery = this.getDataQuery()
  scope.footerButtons = footerButtons(state)
  scope.title = i18n.t('TITLE_DELIVERY_NOTE')
}

DeliveryNoteListController.prototype.getDataQuery = function() {
  return squel.select()
    .from(deliveryNoteTable.name)
    .fields([
      deliveryNoteTable.name + '.date',
      deliveryNoteTable.name + '.id',
      deliveryNoteTable.name + '.name',
      deliveryNoteTable.name + '.status'
    ])
    .field(orderTable.name + '.name', 'orderName')
    .join(orderTable.name, null, deliveryNoteTable.name + '.orderId = ' + orderTable.name + '.id')
    .toString()
}

DeliveryNoteListController.prototype.onLineClick = function(lineId) {
  this.state.go('deliveryNoteLine', {id: lineId})
}

module.exports = DeliveryNoteListController
