var i18n = require('../../i18n')

var HomeSectionController = function(scope, state) {
  this.state = state
  scope.title = i18n.t('TITLE_HOME')
  scope.items = this.items()
  scope.redirect = this.redirect.bind(this)
}

HomeSectionController.prototype.items = function() {
  return [{
    label: 'HOME_INVENTORY',
    route: 'inventoryList',
    add: {
      route: 'inventoryNew'
    }
  }, {
    label: 'HOME_ORDER',
    route: 'orderList',
    add: {
      route: 'orderNew'
    }
  }, {
    label: 'HOME_DELIVERY_NOTE',
    route: 'deliveryNoteList',
    add: {
      route: 'deliveryNoteNew'
    }
  }, {
    label: 'HOME_WASTAGE',
    route: 'wastageList',
    add: {
      route: 'wastageNew'
    }
  }, {
    label: 'HOME_CATALOG',
    route: 'catalogList',
    add: {
      route: 'catalogItem'
    }
  }, {
    label: 'HOME_VENDOR',
    route: 'vendorList',
    add: {
      route: 'vendorDetail'
    }
  }, {
    label: 'HOME_WAREHOUSE',
    route: 'warehouseList',
    add: {
      route: 'warehouseDetail'
    }
  }, {
    label: 'HOME_SYNC',
    route: 'sync'
  }]
  .map(this._prepareNames)
}

HomeSectionController.prototype._prepareNames = function(module) {
  module.name = i18n.t(module.label)
  return module
}

HomeSectionController.prototype.redirect = function(ev, route) {
  ev.stopPropagation()

  this.state.go(route)
}

module.exports = ['$scope', '$state', HomeSectionController]
