var database = require('../../../database')
var inventoryLineTable = require('../../../tables').inventoryLine
var alert = require('../../../lib/alert')

var InventoryLineEditorController = function(scope, state) {
  var self = this
  this.scope = scope
  this.state = state
  scope.lineTableName = inventoryLineTable.name

  this.scope.mainButtons = [{
    icon: 'ion-trash-b',
    class: 'icon-error',
    action: function() {
      self.deleteItem()
    }
  }]
}

InventoryLineEditorController.prototype.deleteItem = function() {
  var self = this
  return alert.askDelete()
  .then(function() {
    return database.delete(
      inventoryLineTable,
      { id: self.scope.inventoryLineId }
    )
  })
  .then(function() {
    alert.success()
    return self.state.go('inventoryLine')
  })
  .catch(function(error) {
    if (error === 'cancel') return //alert cancel
    console.error(error)
    return alert.error()
  })
}

InventoryLineEditorController.prototype._render = function() {
  if (!this.scope.$$phase) {
    this.scope.$digest()
  }
}

module.exports = InventoryLineEditorController
