var inventoryTable = require('../../../tables').inventory
var warehouseTable = require('../../../tables').warehouse
var database = require('../../../database')
var squel = require('squel')
var footerButtons = require('./footer-buttons')
var i18n = require('../../../i18n')

var GRID_HEADERS = {
  name: { label: 'GRID_TH_NAME' },
  date: { label: 'GRID_TH_DATE' },
  status: { label: 'GRID_TH_STATUS' },
  warehouseName: { label: 'GRID_TH_WAREHOUSE' }
}

var InventoryListController = function(scope, state) {
  this.state = state
  scope.gridHeaders = GRID_HEADERS
  scope.gridTable = inventoryTable
  scope.onLineClick = this.onLineClick.bind(this)
  scope.gridDataQuery = this.getDataQuery()
  scope.footerButtons = footerButtons(state)
  scope.title = i18n.t('TITLE_INVENTORY')
}

InventoryListController.prototype.getDataQuery = function() {
  return squel.select()
    .from(inventoryTable.name)
    .fields([
      inventoryTable.name + '.date',
      inventoryTable.name + '.id',
      inventoryTable.name + '.name',
      inventoryTable.name + '.status'
    ])
    .field(warehouseTable.name + '.name', 'warehouseName')
    .join(warehouseTable.name, null, inventoryTable.name + '.warehouseId = ' + warehouseTable.name + '.id')
    .toString()
}

InventoryListController.prototype.onLineClick = function(lineId) {
  this.state.go('inventoryLine', {id: lineId})
}

module.exports = InventoryListController
