var database = require('../../../database')
var orderLineTable = require('../../../tables').orderLine
var alert = require('../../../lib/alert')

var OrderLineEditorController = function(scope, state) {
  var self = this
  this.scope = scope
  this.state = state

  scope.lineTableName = orderLineTable.name

  this.scope.mainButtons = [{
    icon: 'ion-trash-b',
    class: 'icon-error',
    action: function() {
      self.deleteItem()
    }
  }]
}

OrderLineEditorController.prototype.deleteItem = function() {
  var self = this
  return alert.askDelete()
  .then(function() {
    return database.delete(
      orderLineTable,
      { id: self.scope.orderLineId }
    )
  })
  .then(function() {
    alert.success()
    return self.state.go('orderLine')
  })
  .catch(function(error) {
    if (error === 'cancel') return //alert cancel
    console.error(error)
    return alert.error()
  })
}

OrderLineEditorController.prototype._render = function() {
  if (!this.scope.$$phase) {
    this.scope.$digest()
  }
}

module.exports = OrderLineEditorController
