var databaseSyncer = require('../../api/sync')
var Session = require('../../session')
var i18n = require('../../i18n')
var alert = require('../../lib/alert')

function SyncController(scope, state) {
  this.state = state

  scope.onCancel = this.onCancel.bind(this)
  scope.title = i18n.t('MSG_SYNC')
  scope.cancelLabel = i18n.t('BUTTON_CANCEL')

  // called in a timeout because otherwise it would be too fast for the user
  var self = this
  window.setTimeout(function() {
    self._syncAllTables()
  }, 3000)
}

SyncController.prototype._syncAllTables = function() {
  var self = this
  return databaseSyncer.getResources()
  .then(function() {
    alert.success()
    return self.state.go('homeSection')
  })
  .catch(function(error) {
    alert.error()
    return self.onCancel()
  })
}

SyncController.prototype.onCancel = function () {
  Session.clear()
  return this.state.go('login')
}

module.exports = ['$scope', '$state', SyncController]
