var VendorTable = require('../../../tables/').vendor
var squel = require('squel')
var tableKeys = require('../../../lib/tables/keys')(VendorTable)
var i18n = require('../../../i18n')
var footerButtons = require('./footer-buttons')

var GRID_HEADERS = {
  name: { label: 'GRID_TH_NAME' },
  phoneNumber: { label: 'GRID_TH_PHONE_NR' }
}

var VendorListController = function(scope, state) {
  scope.gridHeaders = GRID_HEADERS
  scope.gridTable = VendorTable

  this.state = state

  scope.footerButtons = footerButtons(state)
  scope.gridDataQuery = this._getGridDataQuery()
  scope.onLineClick = this.onLineClick.bind(this)
  scope.title = i18n.t('TITLE_VENDOR')
}

VendorListController.prototype._getGridDataQuery = function() {
  return squel.select()
    .from(VendorTable.name)
    .fields(tableKeys)
    .toString()
}

VendorListController.prototype.onLineClick = function(vendorId) {
  this.state.go('vendorDetail', { id: vendorId })
}

module.exports = VendorListController
