var WarehouseTable = require('../../../tables/').warehouse
var tableKeys = require('../../../lib/tables/keys')
var squel = require('squel')
var i18n = require('../../../i18n')
var footerButtons = require('./footer-buttons')

var GRID_HEADERS = {
  name: { label: 'GRID_TH_NAME' }
}

var WarehouseListController = function(scope, state) {
  scope.gridHeaders = GRID_HEADERS
  scope.gridTable = WarehouseTable

  this.state = state
  scope.footerButtons = footerButtons(state)
  scope.gridDataQuery = this._getGridDataQuery()
  scope.onLineClick = this.onLineClick.bind(this)
  scope.title = i18n.t('TITLE_WAREHOUSE')
}

WarehouseListController.prototype._getGridDataQuery = function() {
  return squel.select()
    .from(WarehouseTable.name)
    .fields(tableKeys)
    .toString()
}

WarehouseListController.prototype.onLineClick = function(warehouseId) {
  this.state.go('warehouseDetail', { id: warehouseId })
}

module.exports = WarehouseListController
