var database = require('../../../database')
var wastageLineTable = require('../../../tables').wastageLine
var alert = require('../../../lib/alert')
var TextField = require('../../../directives/form/fields/text')
var i18n = require('../../../i18n')
var database = require('../../../database/')
var wastageLineTableKeys = require('../../../lib/tables/keys')(wastageLineTable)

var WastageLineEditorController = function(scope, state) {
  var self = this
  this.scope = scope
  this.state = state
  scope.lineTableName = wastageLineTable.name

  this._reasonField = new TextField('reason').setPlaceholder(i18n.t('FIELD_REASON'))
  scope.fields = [ this._reasonField ]

  this.scope.mainButtons = [{
    icon: 'ion-trash-b',
    class: 'icon-error',
    action: function() {
      self.deleteItem()
    }
  }]

  var self = this
  database.read(wastageLineTable, wastageLineTableKeys, { id: self.scope.wastageLineId })
    .then(function(result) {
      self._reasonField.setValue(result[0].reason)
    })
}

WastageLineEditorController.prototype.deleteItem = function() {
  var self = this
  return alert.askDelete()
  .then(function() {
    return database.delete(
      wastageLineTable,
      { id: self.scope.wastageLineId }
    )
  })
  .then(function() {
    alert.success()
    return self.state.go('wastageLine')
  })
  .catch(function(error) {
    if (error === 'cancel') return //alert cancel
    console.error(error)
    return alert.error()
  })
}

WastageLineEditorController.prototype._render = function() {
  if (!this.scope.$$phase) {
    this.scope.$digest()
  }
}

module.exports = WastageLineEditorController
