var wastageTable = require('../../../tables').wastage
var warehouseTable = require('../../../tables').warehouse
var vendorTable = require('../../../tables').vendor
var database = require('../../../database')
var squel = require('squel')
var footerButtons = require('./footer-buttons')
var i18n = require('../../../i18n')

var GRID_HEADERS = {
  name: { label: 'GRID_TH_NAME' },
  date: { label: 'GRID_TH_DATE' },
  status: { label: 'GRID_TH_STATUS' },
  vendorName: { label: 'GRID_TH_VENDOR' },
  warehouseName: { label: 'GRID_TH_WAREHOUSE' }
}

var WastageListController = function(scope, state) {
  this.state = state
  scope.gridHeaders = GRID_HEADERS
  scope.gridTable = wastageTable
  scope.onLineClick = this.onLineClick.bind(this)
  scope.gridDataQuery = this.getDataQuery()
  scope.footerButtons = footerButtons(state)
  scope.title = i18n.t('TITLE_WASTAGE')
}

WastageListController.prototype.getDataQuery = function() {
  return squel.select()
    .from(wastageTable.name)
    .fields([
      wastageTable.name + '.date',
      wastageTable.name + '.id',
      wastageTable.name + '.name',
      wastageTable.name + '.status'
    ])
    .field(warehouseTable.name + '.name', 'warehouseName')
    .field(vendorTable.name + '.name', 'vendorName')
    .join(warehouseTable.name, null, wastageTable.name + '.warehouseId = ' + warehouseTable.name + '.id')
    .join(vendorTable.name, null, wastageTable.name + '.vendorId = ' + vendorTable.name + '.id')
    .toString()
}

WastageListController.prototype.onLineClick = function(lineId) {
  this.state.go('wastageLine', {id: lineId})
}

module.exports = WastageListController
