import * as mysql from 'promise-mysql'
import Promise from 'bluebird'
import config from './config'
import squel from 'squel'
import {dbDebug} from '../../config.json'

var executeSQL = function(statement) {
  let pool = mysql.createPool(config)
  if (dbDebug) { console.log('> ' + statement) }
  return pool.query(statement)
    .then(function(rows) {
      if (dbDebug) { console.log(rows) }
      return Promise.resolve(rows)
    }).catch(function(error) {
      if (dbDebug) { console.error(error) }
      return Promise.reject(error)
    })
}

var getUser = function(username, password) {
  let query = squel.select()
    .fields(['id', 'username', 'password', 'language'])
    .from('User')
    .where('username = ?', username)

  return executeSQL(query.toString())
}

export { getUser }
export default executeSQL