# **MySQL**

## **1. Installation**

```
> sudo apt-get update
> sudo apt-get install mysql-server
> sudo mysql_secure_installation
```
*Remember root password

## **2. Setup**

### **2.2. DB creation**

Connect to MySQL:

```
> mysql -u root -p
```

From the MySQL console:

```
> CREATE DATABASE [nombre_base_datos];
> USE [nombre_base_datos]
> source [ruta hacia fichero install.sql*]
```
\* ./db/mysql/queries.sql by default

### **2.3. Create an user**

Type into the MySQL console:

```
> INSERT INTO User (id, username, password, language) VALUES ('any string as id', 'test', '[generated hash]', '[es-ES|en-GB]')
```
To generate a hash run the server script:

```
> ./scripts/hash [password]
```


# **Utils (not required)**


#### **Check MySQL status**

```
> service mysql status
```

#### **Restart MySQL service**

```
> sudo /etc/init.d/mysql restart
```

#### **Create remote user with all permissions**

First of all, set the host ip in the MySQL config file.

```
> vi /etc/mysql/my.cnf
```

Append

```
[mysqld]
bind-adress=[dirección ip servidor]
```

Create a user with complete permissions (not recommended)

```
> mysql -u root -p -h localhost
> CREATE USER 'username'@'%' IDENTIFIED BY 'password';
> GRANT ALL PRIVILEGES ON *.* TO 'username'@'%' WITH GRANT OPTION;

```