import AbstractService from './abstract'
import executeSQL from '../db/mysql'
import squel from 'squel'
import Promise from 'bluebird'

class AbstractDocumentService extends AbstractService {

  constructor (tableName, lineTable, resource, httpMethods) {
    super(tableName, resource, httpMethods)
    this.lineTable = lineTable
  }

  _insertDocument (doc) {
    let { lines, ...fields } = doc

    console.lof
    const insertLinesQuery = squel.insert()
      .into(this.lineTable)
      .setFieldsRows(lines)

    const insertDocumentQuery = squel.insert()
      .into(this.tableName)
      .setFields(fields)

    console.log(insertDocumentQuery.toString())
    console.log(insertLinesQuery.toString())

    return executeSQL(insertDocumentQuery.toString())
      .then(function() {
        return executeSQL(insertLinesQuery.toString())
      })
  }

  post (req) {
    let promises = []
    const { body } = req

    body.forEach((doc) => {
      promises.push(this._insertDocument(doc))
    })

    return Promise.all(promises)
  }

  put (req) {
    throw new Error('AbstractDocumentService:  not implemented')
  }
}

export default AbstractDocumentService
