import AbstractService from './abstract'
import executeSQL from '../db/mysql'
import squel from 'squel'

class AbstractEntityService extends AbstractService {

  constructor (tableName, resource, httpMethods) {
    super(tableName, resource, httpMethods)
  }

  post (req) {
    const { body } = req
    const query = squel.insert()
      .into(this.tableName)
      .setFieldsRows(body)

    return executeSQL(query.toString())
  }

  put (req) {
    const { body } = req
    let promises = []
    body.forEach((entity) => {
      const {id, ...fields} = entity

      const query = squel.update()
        .table(this.tableName)
        .setFields(fields)
        .where('id = ?', id)

      promises.push(executeSQL(query.toString()))
    })

    return Promise.all(promises)
  }
}

export default AbstractEntityService
