import AbstractService from './abstract'
import fetch from 'node-fetch'

const apiUrl = 'http://www.barcodefinder.com/search?q=[:barcode-number]&format=json'

class EanSearchService extends AbstractService {

  get (req) {
    const { query } = req

    const url = apiUrl.replace('[:barcode-number]', query.ean)
    const options = {
      method: 'get',
      headers: {'Content-Type': 'text/plain'}
    }

    return fetch(url, options)
      .then((response) => response.text())
      .then((response) => JSON.parse(response))
  }

  _execute (req, res ) {
    return this.get(req)
    .then((result) => res.json(result))
    .catch((error) => res.json(error))
  }

  load (router) {
    router.get('/ean-search', (req, res) => { this._execute(req, res) })
  }
}

export default EanSearchService
